﻿// CodeGear C++Builder
// Copyright (c) 1995, 2021 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'LogFile.pas' rev: 35.00 (Windows)

#ifndef LogfileHPP
#define LogfileHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <Winapi.Windows.hpp>
#include <System.SysUtils.hpp>
#include <System.Classes.hpp>
#include <LogBase.hpp>

//-- user supplied -----------------------------------------------------------

namespace Logfile
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS EFileNotificationError;
class DELPHICLASS TNotificationThread;
class DELPHICLASS TSMFileLog;
//-- type declarations -------------------------------------------------------
#pragma pack(push,4)
class PASCALIMPLEMENTATION EFileNotificationError : public System::Sysutils::Exception
{
	typedef System::Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ inline __fastcall EFileNotificationError(const System::UnicodeString Msg) : System::Sysutils::Exception(Msg) { }
	/* Exception.CreateFmt */ inline __fastcall EFileNotificationError(const System::UnicodeString Msg, const System::TVarRec *Args, const int Args_High) : System::Sysutils::Exception(Msg, Args, Args_High) { }
	/* Exception.CreateRes */ inline __fastcall EFileNotificationError(NativeUInt Ident)/* overload */ : System::Sysutils::Exception(Ident) { }
	/* Exception.CreateRes */ inline __fastcall EFileNotificationError(System::PResStringRec ResStringRec)/* overload */ : System::Sysutils::Exception(ResStringRec) { }
	/* Exception.CreateResFmt */ inline __fastcall EFileNotificationError(NativeUInt Ident, const System::TVarRec *Args, const int Args_High)/* overload */ : System::Sysutils::Exception(Ident, Args, Args_High) { }
	/* Exception.CreateResFmt */ inline __fastcall EFileNotificationError(System::PResStringRec ResStringRec, const System::TVarRec *Args, const int Args_High)/* overload */ : System::Sysutils::Exception(ResStringRec, Args, Args_High) { }
	/* Exception.CreateHelp */ inline __fastcall EFileNotificationError(const System::UnicodeString Msg, int AHelpContext) : System::Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ inline __fastcall EFileNotificationError(const System::UnicodeString Msg, const System::TVarRec *Args, const int Args_High, int AHelpContext) : System::Sysutils::Exception(Msg, Args, Args_High, AHelpContext) { }
	/* Exception.CreateResHelp */ inline __fastcall EFileNotificationError(NativeUInt Ident, int AHelpContext)/* overload */ : System::Sysutils::Exception(Ident, AHelpContext) { }
	/* Exception.CreateResHelp */ inline __fastcall EFileNotificationError(System::PResStringRec ResStringRec, int AHelpContext)/* overload */ : System::Sysutils::Exception(ResStringRec, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ inline __fastcall EFileNotificationError(System::PResStringRec ResStringRec, const System::TVarRec *Args, const int Args_High, int AHelpContext)/* overload */ : System::Sysutils::Exception(ResStringRec, Args, Args_High, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ inline __fastcall EFileNotificationError(NativeUInt Ident, const System::TVarRec *Args, const int Args_High, int AHelpContext)/* overload */ : System::Sysutils::Exception(Ident, Args, Args_High, AHelpContext) { }
	/* Exception.Destroy */ inline __fastcall virtual ~EFileNotificationError() { }
	
};

#pragma pack(pop)

enum DECLSPEC_DENUM TFileNotificationOption : unsigned char { foFile, foFolder, foAttributes, foSize, foTime, foWatchSubFolders };

typedef System::Set<TFileNotificationOption, TFileNotificationOption::foFile, TFileNotificationOption::foWatchSubFolders> TFileNotificationOptions;

typedef void __fastcall (__closure *TFileNotifyEvent)(System::TObject* Sender, TFileNotificationOption Action);

class PASCALIMPLEMENTATION TNotificationThread : public System::Classes::TThread
{
	typedef System::Classes::TThread inherited;
	
private:
	TSMFileLog* FOwner;
	System::StaticArray<NativeUInt, 8> FHandles;
	System::StaticArray<TFileNotificationOption, 8> FHandleFilters;
	int FHandleCount;
	TFileNotificationOption FActiveFilter;
	void __fastcall ReleaseHandles();
	void __fastcall AllocateHandles();
	
protected:
	virtual void __fastcall Execute();
	void __fastcall Notify();
	
public:
	__fastcall TNotificationThread(TSMFileLog* Owner);
	__fastcall virtual ~TNotificationThread();
	void __fastcall Reset();
};


class PASCALIMPLEMENTATION TSMFileLog : public Logbase::TSMLogBase
{
	typedef Logbase::TSMLogBase inherited;
	
private:
	TNotificationThread* FThread;
	System::UnicodeString FFolder;
	TFileNotificationOptions FOptions;
	TFileNotifyEvent FOnFileNotification;
	void __fastcall SetOptions(TFileNotificationOptions Value);
	void __fastcall SetFolder(System::UnicodeString Value);
	
protected:
	virtual void __fastcall Notify(TFileNotificationOption Action);
	virtual void __fastcall Loaded();
	virtual void __fastcall SetActive(bool Value);
	
public:
	__fastcall virtual TSMFileLog(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TSMFileLog();
	
__published:
	__property System::UnicodeString Folder = {read=FFolder, write=SetFolder};
	__property TFileNotificationOptions Options = {read=FOptions, write=SetOptions, nodefault};
	__property TFileNotifyEvent OnFileNotification = {read=FOnFileNotification, write=FOnFileNotification};
};


//-- var, const, procedure ---------------------------------------------------
extern "C" NativeUInt __stdcall FindFirstChangeNotification(System::WideChar * lpPathName, unsigned bWatchSubtree, unsigned dwNotifyFilter);
}	/* namespace Logfile */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_LOGFILE)
using namespace Logfile;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// LogfileHPP
